Attribute VB_Name = "Module1"
Option Explicit
Public blnDrawOver As Boolean
Public mult As Single
Public blnFlip90 As Boolean
Public testacc As Boolean
Public acc_dec As Boolean
Public blnJump As Boolean
Public ZHigh As Boolean
Public decimalXY As Single
Public Speed As Long
Public mainlostfocus As Boolean
Public blnOSP As Boolean
Public blnPause As Boolean
Public strPath2 As String ' OPEN AND SAVE STRING FOR RICHTEXTBOX2
Public blnSimulate As Boolean ' SIMULATION BINARY
Public X_p As Double 'USED IN PLOT
Public Y_p As Double 'USED IN PLOT
Public Z_p As Double 'USED IN PLOT
Public LeftRight As Double 'USED IN PLOT OFFSET
Public UpDown As Double 'USED IN PLOT OFFSET
Public InstructionNumber As Single 'INTRUCTION COUNT
Public IPPM As Single ' used in comms
'Public Y_p% '2000 p/i
Public blnWaitForComm As Boolean
Public PortWord As Long 'THE BYTE USED TO CONTROL PORT
Public X_inches As Single ' IN INCHES
Public Y_inches As Single
Public Z_inches As Single
Public I_inches As Single ' IN INCHES
Public J_inches As Single
Public K_inches As Single
Public G_Codenum As G_Code
Public InchPerMin As Single ' YEA
Public G0InchPerMin As Single ' ANOTHER YUP
Public Const PI2 = 6.28 ' NOT TO EXACT BECAUSE HOW
Public Const PI = 3.14 '  MUCH PRECISION DO WE REALLY NEED
Public Const halfPI = 1.57
Public Comp As Single 'the compensation amount
Public CutterComp As Byte ' type of comp or none at all
Public CompCount As Byte 'que in sub
Public LastCompLine As Boolean 'last move
Public IncrementalInput As Boolean
Public TempfinX As Long
Public TempfinY As Long
Public TempfinZ As Long
Private setEnd As Boolean
Public Max_X_P As Single
Public Max_X_N As Single
Public Max_Y_P As Single
Public Max_Y_N As Single
'***********************
Enum G_Code
    G00Q = 0
    G01L = 1
    G02CW = 2
    G03CCW = 3
    G04Timer = 4
    G40CompOff = 40
    G40CompRH = 41
    G40CompLH = 42
End Enum
Type HoldData1
        HoldData As Boolean
        Hx_p  As Double
        HY_p As Double
        Hz_p As Double
        HX_inches As Single
        HY_inches  As Single
        HZ_inches  As Single
End Type
Type DrawingOffset1
    PPX As Single
    PPY As Single
End Type
Type CBox
    G_Box As G_Code
    IPM_Box As Single
    X_Box(1, 1) As Single
    Y_Box(1, 1) As Single
    Z_Box(1, 1) As Single
    Dir_Box(3) As Single
    Offset As Single
    OffNewA As Single
    NewRadius As Single
    Hyp_Box As Single
    Opp_Box As Single
    I_Box As Single
    J_Box As Single
    K_Box As Single
End Type
Public HoldData As HoldData1
Public exeBox As CBox
Public preBox As CBox
Public DrawingOffset As DrawingOffset1
Dim precomp As Long
'***********************


Public Function Dir(ByVal t As Single) As Single
    Dir = t * (180 / PI)
End Function

Function X(ByVal t As Single, Radius As Single) As Single
    X = Radius * Cos(t)
End Function

Function Y(ByVal t As Single, Radius As Single) As Single
    Y = Radius * Sin(t)
End Function

Public Function ATan2(ByVal dy As Single, ByVal dx As Single) As Single
    'This function gives us the angle of the arc tangent
    'corrected for the quadrant it's in. Standard XY plane
    Dim theta As Single
    If Abs(dx) < 0.0001 Then
        If dy < 0 Then
            theta = PI * 1.5
        Else
            theta = halfPI
        End If
    Else
        theta = Atn(dy / dx)
        If dx < 0 Then
            theta = PI + theta
        ElseIf dy < 0 Then
            theta = 2 * PI + theta
        End If
    End If
    If theta < 0.0002 Then theta = 0
    ATan2 = theta
End Function

Public Sub resetMe()
    Mainform.cmdZeroMe_MouseDown 0, 0, 0, 0
    Pict.Cls
    Mainform.cmdZeroMe_MouseUp 0, 0, 0, 0
    Mainform.Form_Load
    CutterComp = 0
    Mainform.Command3.Caption = "Comp.Off"
    Mainform.Command3.BackColor = &H8000000F
    Mainform.cmdSimulate.BackColor = &HFF00&
    Mainform.cmdSimulate.Caption = "Simulate"
    blnSimulate = True
    Mainform.cmdRunProgram.Caption = "Test Program"
    IPPM = 34
End Sub

Public Sub DirIndStreight()
    Mainform.Label9.ForeColor = &HFF00& '    direction indicator
    Mainform.Label10.ForeColor = &H80000012 'direction indicator
    Mainform.Label11.ForeColor = &H80000012
    DoEvents
End Sub

Public Sub DirIndCW()
    Mainform.Label9.ForeColor = &H80000012 'direction indicator
    Mainform.Label10.ForeColor = &HFF00& '    direction indicator
    Mainform.Label11.ForeColor = &H80000012 ' direction indicator
    DoEvents
End Sub

Public Sub DirIndCCW()
    Mainform.Label9.ForeColor = &H80000012 ' direction indicator
    Mainform.Label10.ForeColor = &H80000012 'direction indicator
    Mainform.Label11.ForeColor = &HFF00& '   direction indicator
    DoEvents
End Sub

Public Sub ParseText()
    Dim strText As String
    Dim strcmdTXT As String
    Dim strLen As Long
    Static strCount As Long
    strText = Mainform.RichTextBox1.Text
    strText = VBA.UCase$(strText) 'Cap's
    Mainform.RichTextBox1.Text = strText
    strLen = Len(strText) 'look for an E or END to pause
    If strLen = 0 Then
        Mainform.RichTextBox2.SelText = "No Code Detected, Please Load Code." + Chr(10)
        Exit Sub
    End If
    strCount = InStr(1, strText, "%") 'removes excess program to stop from hanging after END
    If strCount = 0 Then
        strText = "%" + Chr(10) + strText
        Mainform.RichTextBox1.Text = strText
    End If
    strCount = InStr(1, strText, "E") 'removes excess program to stop from hanging after END
    If strCount = 0 Then
        If InStr(Len(strText) - 2, strText, Chr(10)) Then
            strText = strText + "E"
        Else
            strText = strText + Chr(10) + "E"
        End If
        Mainform.RichTextBox1.Text = strText
    End If
    If strCount = 0 Then Mainform.RichTextBox2.SelText = "Program Format Corrected." + Chr(10) + "Please Try Again." + Chr(10)
    If strCount > 0 Then Mainform.RichTextBox2.Text = ""
    strText = Left$(strText, strCount)
    If blnJump = True Then
        strCount = Len(strText) - InStr(1, strText, "JUMP")
        strText = Right$(strText, strCount)
    End If
    Do
        strLen = Len(strText)
        strCount = InStr(1, strText, Chr(10))
        strcmdTXT = Left$(strText, strCount)
        strText = Right$(strText, strLen - strCount)
        conditionText strcmdTXT
        If blnPause = True Then GoTo PauseMe
        DoEvents
    Loop Until Len(strText) < 2
    setEnd = False
    Exit Sub
PauseMe:
    'Set strText = Nothing
End Sub

Public Sub conditionText(yy As String)
    Dim CTG As G_Code
    Dim CTX As Single
    Dim CTY As Single
    Dim CTZ As Single
    Dim CTI As Single
    Dim CTJ As Single
    Dim CTK As Single
    Dim CTF As Single
    Dim setNeg As Boolean
    Dim dummy As String
    Dim CTcmds As String
    Dim leftstr As String
    Dim inPos As Long
    Dim strLen As Long
    Dim count As Long
    CTG = 50000
    CTX = 50000
    CTY = 50000
    CTZ = 50000
    CTI = 50000
    CTJ = 50000
    CTK = 50000
    CTF = 50000
    Trim (yy)
    yy = Replace(yy, Chr(10), "B")
    yy = Replace(yy, Chr(13), "B")
    strLen = Len(yy)
    
    If InStr(1, yy, "END") > 0 Then setEnd = True
    If setEnd = True Then Exit Sub
    If InStr(1, yy, "%") > 0 Then InchPerMin = 4
    If VBA.InStr(1, yy, "H") > 0 Then
        yy = Replace(yy, "H", "")
        Mainform.cmdHomeMe_Click (0)
        Mainform.RichTextBox2.SelText = "Home" + Chr(10)
    End If
    If Left$(yy, 1) = "N" Then
        count = 1
        Do
            count = count + 1
        Loop Until IsNumeric(Mid(yy, inPos + count, 1)) = False
        yy = Right$(yy, strLen - count)
    End If
    If VBA.InStr(1, yy, "G90") > 0 Then
        yy = Replace(yy, "G90", "")
        IncrementalInput = False
        'Mainform.AbsoluteIn.Caption = "Absolute Input"
    End If
    If VBA.InStr(1, yy, "G91") > 0 Then
        yy = Replace(yy, "G91", "")
        IncrementalInput = True
        'Mainform.AbsoluteIn.Caption = "Incremental"
    End If
    If VBA.InStr(1, yy, "G40") > 0 Then
        yy = Replace(yy, "G40", "")
        CutterComp = 0
        Mainform.Command3.Caption = "Comp.Off"
        Mainform.Command3.BackColor = &H8000000F
    End If
    If VBA.InStr(1, yy, "G41") > 0 Then
        yy = Replace(yy, "G41", "")
        CutterComp = 1
        Mainform.Command3.Caption = "Comp.Left"
        Mainform.Command3.BackColor = &HFFFF&
    End If
    If VBA.InStr(1, yy, "G42") > 0 Then
        yy = Replace(yy, "G42", "")
        CutterComp = 2
        Mainform.Command3.Caption = "Comp.Right"
        Mainform.Command3.BackColor = &H80FF&
    End If
    If InStr(1, yy, "G01") > 0 Or InStr(1, yy, "G1") > 0 Then
        CTG = 1
        yy = Replace(yy, "G01", "")
        yy = Replace(yy, "G1", "")
    End If
    If InStr(1, yy, "G02") > 0 Or InStr(1, yy, "G2") > 0 Then
        CTG = 2
        yy = Replace(yy, "G02", "")
        yy = Replace(yy, "G2", "")
    End If
    If InStr(1, yy, "G03") > 0 Or InStr(1, yy, "G3") > 0 Then
        CTG = 3
        yy = Replace(yy, "G03", "")
        yy = Replace(yy, "G3", "")
    End If
    If InStr(1, yy, "G04") > 0 Or InStr(1, yy, "G4") > 0 Then
        CTG = 4
        yy = Replace(yy, "G04", "")
        yy = Replace(yy, "G4", "")
    End If
    If InStr(1, yy, "G00") > 0 Or InStr(1, yy, "G0") > 0 Then
        CTG = 0
        yy = Replace(yy, "G00", "")
        yy = Replace(yy, "G0", "")
    End If
    Trim (yy)
    If InStr(1, yy, "X") > 0 Then
        count = 0
        inPos = InStr(1, yy, "X") + 1
        Do
            count = count + 1
        Loop Until IsNumeric(Mid(yy, inPos + count, 1)) = False And Mid(yy, inPos + count, 1) <> "-" And Mid(yy, inPos + count, 1) <> "."
        CTX = CSng(Mid(yy, inPos, count)) + DrawingOffset.PPX
    End If
    If InStr(1, yy, "Y") > 0 Then
        count = 0
        inPos = InStr(1, yy, "Y") + 1
        Do
            count = count + 1
        Loop Until IsNumeric(Mid(yy, inPos + count, 1)) = False And Mid(yy, inPos, count) <> "-" And Mid(yy, inPos + count, 1) <> "."
        CTY = CSng(Mid(yy, inPos, count)) + DrawingOffset.PPY
    End If
    If InStr(1, yy, "Z") > 0 Then
        count = 0
        inPos = InStr(1, yy, "Z") + 1
        Do
            count = count + 1
        Loop Until IsNumeric(Mid(yy, inPos + count, 1)) = False And Mid(yy, inPos + count, 1) <> "-" And Mid(yy, inPos + count, 1) <> "."
        CTZ = CSng(Mid(yy, inPos, count))
    End If
    If InStr(1, yy, "I") > 0 Then
        count = 0
         inPos = InStr(1, yy, "I") + 1
        Do
            count = count + 1
        Loop Until IsNumeric(Mid(yy, inPos + count, 1)) = False And Mid(yy, inPos + count, 1) <> "-" And Mid(yy, inPos + count, 1) <> "."
        CTI = CSng(Mid(yy, inPos, count)) + DrawingOffset.PPX
    End If
    If InStr(1, yy, "J") > 0 Then
        count = 0
        inPos = InStr(1, yy, "J") + 1
        Do
            count = count + 1
        Loop Until IsNumeric(Mid(yy, inPos + count, 1)) = False And Mid(yy, inPos + count, 1) <> "-" And Mid(yy, inPos + count, 1) <> "."
        CTJ = CSng(Mid(yy, inPos, count)) + DrawingOffset.PPY
    End If
    If InStr(1, yy, "K") > 0 Then
        count = 0
        inPos = InStr(1, yy, "K") + 1
        Do
            count = count + 1
        Loop Until IsNumeric(Mid(yy, inPos + count, 1)) = False And Mid(yy, inPos + count, 1) <> "-" And Mid(yy, inPos + count, 1) <> "."
        CTK = CSng(Mid(yy, inPos, count))
    End If
    If InStr(1, yy, "F") > 0 Then
        count = 0
        inPos = InStr(1, yy, "F") + 1
        Do
            count = count + 1
        Loop Until IsNumeric(Mid(yy, inPos + count, 1)) = False
        CTF = CSng(Mid(yy, inPos, count))
    End If
    If CTX + CTY + CTZ + CTI + CTJ + CTK + CTF <> 350000 Then
        If blnFlip90 = True Then
            InitialDataCmd CTG, CTY, CTX, CTZ, CTF, CTJ, CTI, CTK
        Else
            InitialDataCmd CTG, CTX, CTY, CTZ, CTF, CTI, CTJ, CTK
        End If
    End If
    If CTG = G04Timer Then
        If InStr(1, yy, "/") > 0 Then
            count = 0
            inPos = InStr(1, yy, "/") + 1
            Do
                count = count + 1
            Loop Until IsNumeric(Mid(yy, inPos + count, 1)) = False And Mid(yy, inPos + count, 1) <> "-" And Mid(yy, inPos + count, 1) <> "."
            Mainform.Timer1.Interval = CSng(Mid(yy, inPos, count))
            Mainform.Timer1.Enabled = True
            Do
                DoEvents
                If blnPause = True Then Exit Do
            Loop Until Mainform.Timer1.Enabled = False
        End If
    End If
End Sub

Public Sub InitialDataCmd(Optional G As G_Code = 50000, Optional X_IN As Single = 50000, Optional Y_IN As Single = 50000, Optional Z_IN As Single = 50000, Optional IPM As Single = 50000, Optional I_IN As Single = 50000, Optional J_IN As Single = 50000, Optional K_IN As Single = 50000, Optional cmds As String)
    InstructionNumber = InstructionNumber + 1: Mainform.Label12.Caption = InstructionNumber
    If G = 50000 Then
        G = G_Codenum
    End If
    If I_IN = 50000 Then
        I_IN = I_inches '+ DrawingOffset.PPX
    Else
        I_IN = I_IN * mult
    End If
    If J_IN = 50000 Then
        J_IN = J_inches '+ DrawingOffset.PPY
    Else
        J_IN = J_IN * mult
    End If
    If K_IN = 50000 Then
        K_IN = K_inches
    End If
    '***************************
    If X_IN = 50000 Then
            X_IN = X_inches '+ DrawingOffset.PPX
    Else
            X_IN = X_IN * mult
    End If
    If Y_IN = 50000 Then
            Y_IN = Y_inches '+ DrawingOffset.PPY
    Else
            Y_IN = Y_IN * mult
    End If
    If Z_IN = 50000 Then
            Z_IN = Z_inches
    End If
    '***************************
    G_Codenum = G
    X_inches = X_IN
    Y_inches = Y_IN
    Z_inches = Z_IN
    I_inches = I_IN
    J_inches = J_IN
    K_inches = K_IN
    
    If IPM <> 50000 Then
        If IPM > 20 Then IPM = 20
        If IPM < 0.1 Then IPM = 0.1
        'IPPM = IPM
        IPM = (1 / (IPM * 10)) * 250 + 8
        If IPM > 250 Then IPM = 250
        If IPM < 8 Then IPM = 8
        IPPM = IPM
    Else
        IPM = IPPM
    End If
    If IPM < 0.0001 Then IPM = 0.0001
    'If blnSimulate = True Then IPM = 0.000001
    '***************************
    If CutterComp > 0 Then 'Or LastCompLine = True Then
        If CutterComp = 1 Then
            BoxCutLEFT G, X_IN, Y_IN, Z_IN, IPM, I_IN, J_IN, K_IN
        ElseIf CutterComp = 2 Then
            BoxCutRIGHT G, X_IN, Y_IN, Z_IN, IPM, I_IN, J_IN, K_IN
        End If
    End If
    If CutterComp = 0 And LastCompLine = True Then
        If precomp = 1 Then
            precomp = 0
            BoxCutLEFT G, X_IN, Y_IN, Z_IN, IPM, I_IN, J_IN, K_IN
        ElseIf precomp = 2 Then
            precomp = 0
            BoxCutRIGHT G, X_IN, Y_IN, Z_IN, IPM, I_IN, J_IN, K_IN
        End If
        LastCompLine = False
    End If
    If LastCompLine = True Then
        precomp = G
        Exit Sub
    End If
    '***************************
    Select Case G
        Case 0
            DirIndStreight
            G_01 X_IN, Y_IN, Z_IN, IPM, I_IN, J_IN, K_IN
        Case 1
            DirIndStreight
            G_01 X_IN, Y_IN, Z_IN, IPM, I_IN, J_IN, K_IN
        Case 2
            G_02 X_IN, Y_IN, Z_IN, IPM, I_IN, J_IN, K_IN
        Case 3
            G_03 X_IN, Y_IN, Z_IN, IPM, I_IN, J_IN, K_IN
    End Select
    '***************************
    'X_inches = X_IN
    'Y_inches = Y_IN
    'Z_inches = Z_IN
End Sub

Public Sub BoxCutLEFT(G As G_Code, EndX As Single, EndY As Single, EndZ As Single, IPM As Single, PointI As Single, PointJ As Single, PointK As Single)
    Dim Di(4) As Single
    Dim dummy As Single
                    Dim length As Single
                    Dim MinX As Single
                    Dim MinY As Single
                    Dim MaxX As Single
                    Dim MaxY As Single
                    Dim deltaX As Single
                    Dim deltaY As Single
                    Dim radXY As Single
                    Dim count1 As Single
                    Dim count15 As Single
                    Dim instruct As String
    '***THE FOLLOWING SETS UP NON COMPENSATED PATHS
    Select Case exeBox.G_Box
        Case 0 To 1
            instruct = "Lin"
        Case 2
            instruct = "ArcCW"
        Case 3
            instruct = "ArcCCW"
    End Select
    Mainform.RichTextBox2.SelText = instruct + " X" + CStr(preBox.X_Box(0, 1)) + "Y" + CStr(preBox.Y_Box(0, 1)) + Chr(13) + Chr(10)
    exeBox = preBox 'before an exe pre process with pre
    preBox.IPM_Box = IPM '       :
    preBox.X_Box(0, 1) = EndX '              :PRE MOVE CONTROL POINTS
    preBox.Y_Box(0, 1) = EndY '              :PRE MOVE CONTROL POINTS
    preBox.Z_Box(0, 1) = EndZ '              :PRE MOVE CONTROL POINTS
    preBox.X_Box(0, 0) = exeBox.X_Box(0, 1) ':PRE MOVE CONTROL POINTS
    preBox.Y_Box(0, 0) = exeBox.Y_Box(0, 1) ':PRE MOVE CONTROL POINTS
    preBox.Z_Box(0, 0) = exeBox.Z_Box(0, 1) ':PRE MOVE CONTROL POINTS
    preBox.I_Box = PointI '    :
    preBox.J_Box = PointJ '    :
    preBox.K_Box = PointK '    :
    preBox.G_Box = G '
    '**********************************************
    '**********************************************
    If CutterComp = 1 Then 'CutterComp = 1 is Lefthand Compensation
        If LastCompLine = False And CutterComp = 1 Then 'checks for two instructions in que
            LastCompLine = True
            preBox.X_Box(0, 0) = X_inches: preBox.Y_Box(0, 0) = Y_inches: preBox.Z_Box(0, 0) = Z_inches 'Loads a start point
            'Dir_Box(0) is always this command  exiting direction
            preBox.Dir_Box(0) = Format(ATan2(preBox.Y_Box(0, 1) - preBox.Y_Box(0, 0), preBox.X_Box(0, 1) - preBox.X_Box(0, 0)), "0.###")
            preBox.Dir_Box(1) = preBox.Dir_Box(0)
            preBox.Dir_Box(2) = preBox.Dir_Box(0) + halfPI
            preBox.Dir_Box(3) = preBox.Dir_Box(1) + halfPI
            If preBox.Dir_Box(0) < 0 Then preBox.Dir_Box(0) = preBox.Dir_Box(0) + PI2
            If preBox.Dir_Box(0) > PI2 Then preBox.Dir_Box(0) = preBox.Dir_Box(0) - PI2
            If preBox.Dir_Box(1) < 0 Then preBox.Dir_Box(1) = preBox.Dir_Box(1) + PI2
            If preBox.Dir_Box(1) > PI2 Then preBox.Dir_Box(1) = preBox.Dir_Box(1) - PI2
            If preBox.Dir_Box(2) < 0 Then preBox.Dir_Box(2) = preBox.Dir_Box(2) + PI2
            If preBox.Dir_Box(2) > PI2 Then preBox.Dir_Box(2) = preBox.Dir_Box(2) - PI2
            If preBox.Dir_Box(3) < 0 Then preBox.Dir_Box(3) = preBox.Dir_Box(3) + PI2
            If preBox.Dir_Box(3) > PI2 Then preBox.Dir_Box(3) = preBox.Dir_Box(3) - PI2
            Exit Sub 'the first line is loaded
        End If
        
        If preBox.G_Box = 0 Or preBox.G_Box = 1 Then
            'Dir_Box(0) is always this command  exiting direction
            preBox.Dir_Box(0) = Format(ATan2(preBox.Y_Box(0, 1) - preBox.Y_Box(0, 0), preBox.X_Box(0, 1) - preBox.X_Box(0, 0)), "0.###")
            preBox.Dir_Box(1) = Format(preBox.Dir_Box(0), "0.###")
            preBox.Dir_Box(2) = Format(preBox.Dir_Box(0) + halfPI, "0.###")
            preBox.Dir_Box(3) = Format(preBox.Dir_Box(1) + halfPI, "0.###")
            dummy = dummy
        End If
        If preBox.G_Box = 2 Then
            preBox.NewRadius = Sqr((preBox.J_Box - preBox.Y_Box(0, 0)) ^ 2 + (preBox.I_Box - preBox.X_Box(0, 0)) ^ 2)
            'Dir_Box(0) is always this CW command  enter direction
            preBox.Dir_Box(0) = Format(ATan2(preBox.J_Box - preBox.Y_Box(0, 0), preBox.I_Box - preBox.X_Box(0, 0)) + halfPI, "0.###")
            'Dir_Box(1) is always this CW command  exit direction
            preBox.Dir_Box(1) = Format(ATan2(preBox.J_Box - preBox.Y_Box(0, 1), preBox.I_Box - preBox.X_Box(0, 1)) + halfPI, "0.###")
            preBox.Dir_Box(2) = Format(preBox.Dir_Box(0) + halfPI, "0.###")
            preBox.Dir_Box(3) = Format(preBox.Dir_Box(1) + halfPI, "0.###")
            dummy = dummy
        End If
        If preBox.G_Box = 3 Then
            preBox.NewRadius = Sqr((preBox.J_Box - preBox.Y_Box(0, 0)) ^ 2 + (preBox.I_Box - preBox.X_Box(0, 0)) ^ 2)
            'Dir_Box(1) is always this CW command  entering direction
            preBox.Dir_Box(0) = Format(ATan2(preBox.Y_Box(0, 0) - preBox.J_Box, preBox.X_Box(0, 0) - preBox.I_Box) + halfPI, "0.###")
            'Dir_Box(0) is always this CW command  exiting direction
            preBox.Dir_Box(1) = Format(ATan2(preBox.Y_Box(0, 1) - preBox.J_Box, preBox.X_Box(0, 1) - preBox.I_Box) + halfPI, "0.###")
            preBox.Dir_Box(2) = Format(preBox.Dir_Box(0) + halfPI, "0.###")
            preBox.Dir_Box(3) = Format(preBox.Dir_Box(1) + halfPI, "0.###")
            dummy = dummy
        End If
    End If
    'Normal Range********************
    If preBox.Dir_Box(0) < 0 Then preBox.Dir_Box(0) = Format(preBox.Dir_Box(0) + PI2, "0.###")
    If preBox.Dir_Box(0) >= PI2 Then preBox.Dir_Box(0) = Format(preBox.Dir_Box(0) - PI2, "0.###")
    If preBox.Dir_Box(1) < 0 Then preBox.Dir_Box(1) = Format(preBox.Dir_Box(1) + PI2, "0.###")
    If preBox.Dir_Box(1) >= PI2 Then preBox.Dir_Box(1) = Format(preBox.Dir_Box(1) - PI2, "0.###")
    If preBox.Dir_Box(2) < 0 Then preBox.Dir_Box(2) = Format(preBox.Dir_Box(2) + PI2, "0.###")
    If preBox.Dir_Box(2) >= PI2 Then preBox.Dir_Box(2) = Format(preBox.Dir_Box(2) - PI2, "0.###")
    If preBox.Dir_Box(3) < 0 Then preBox.Dir_Box(3) = Format(preBox.Dir_Box(3) + PI2, "0.###")
    If preBox.Dir_Box(3) >= PI2 Then preBox.Dir_Box(3) = Format(preBox.Dir_Box(3) - PI2, "0.###")
    dummy = dummy
    'Normal Range********************
    exeBox.Offset = Format(exeBox.Dir_Box(1) - preBox.Dir_Box(0), "0.##")
    If exeBox.Offset + PI <= -0.0001 Then exeBox.Offset = Format(exeBox.Offset + PI2, "0.###")
    If exeBox.Offset >= PI + 0.0001 Then exeBox.Offset = Format(exeBox.Offset - PI2, "0.###")
    '********************************
    'default
    preBox.X_Box(1, 0) = Format(X(preBox.Dir_Box(2), Comp) + preBox.X_Box(0, 0), "#0.####")
    preBox.X_Box(1, 1) = Format(X(preBox.Dir_Box(3), Comp) + preBox.X_Box(0, 1), "#0.####")
    preBox.Y_Box(1, 0) = Format(Y(preBox.Dir_Box(2), Comp) + preBox.Y_Box(0, 0), "#0.####")
    preBox.Y_Box(1, 1) = Format(Y(preBox.Dir_Box(3), Comp) + preBox.Y_Box(0, 1), "#0.####")
    
    If exeBox.G_Box = G00Q Or exeBox.G_Box = G01L Then
        If exeBox.Offset = 0 Then
                DirIndStreight
                G_01 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, PointI, PointJ, PointK
        ElseIf exeBox.Offset > 0 Then
                DirIndStreight
                G_01 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, PointI, PointJ, PointK
                preBox.X_Box(1, 0) = X(preBox.Dir_Box(2), Comp) + preBox.X_Box(0, 0)
                preBox.Y_Box(1, 0) = Y(preBox.Dir_Box(2), Comp) + preBox.Y_Box(0, 0)
                G_02 preBox.X_Box(1, 0), preBox.Y_Box(1, 0), exeBox.Z_Box(0, 1), IPM, exeBox.X_Box(0, 1), exeBox.Y_Box(0, 1), exeBox.K_Box
        ElseIf exeBox.Offset < 0 Then
            If preBox.G_Box = G00Q Or preBox.G_Box = G01L Then
                exeBox.Hyp_Box = Format(1 / (Cos(Abs(exeBox.Offset / 2)) / Comp), "#0.####")
                If exeBox.Hyp_Box > 6 Or exeBox.Hyp_Box < -6 Then
                    exeBox.Hyp_Box = 0
                    MsgBox "Fault in HYP BOX CALC"
                End If
                exeBox.X_Box(1, 1) = Format(X((exeBox.Offset / -2) + exeBox.Dir_Box(1) + halfPI, exeBox.Hyp_Box), "#0.####") + exeBox.X_Box(0, 1)
                exeBox.Y_Box(1, 1) = Format(Y((exeBox.Offset / -2) + exeBox.Dir_Box(1) + halfPI, exeBox.Hyp_Box), "#0.####") + exeBox.Y_Box(0, 1)
                DirIndStreight
                G_01 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, PointI, PointJ, PointK
            ElseIf preBox.G_Box = G02CW Then
                    '11111111111111111111111111111111
                    length = Sqr((exeBox.X_Box(0, 1) - exeBox.X_Box(0, 0)) ^ 2 + (exeBox.Y_Box(0, 1) - exeBox.Y_Box(0, 0)) ^ 2)
                    MinX = exeBox.X_Box(1, 0)
                    MaxX = exeBox.X_Box(1, 1)
                    MinY = exeBox.Y_Box(1, 0)
                    MaxY = exeBox.Y_Box(1, 1)
                    For count1 = 0 To length Step 0.0001
                        count15 = count15 + 1
                        deltaX = (count1 / length) * (MaxX - MinX) + MinX
                        deltaY = (count1 / length) * (MaxY - MinY) + MinY
                        radXY = Sqr((deltaY - preBox.J_Box) ^ 2 + (deltaX - preBox.I_Box) ^ 2)
                        If radXY < (preBox.NewRadius + Comp) Then
                            exeBox.X_Box(1, 1) = deltaX
                            exeBox.Y_Box(1, 1) = deltaY
                            GoTo exception1B
                        End If
                    Next count1
exception1B:
                    DirIndStreight
                    G_01 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, PointI, PointJ, PointK
            ElseIf preBox.G_Box = G03CCW Then
                    '22222222222222222222222222222222
                    length = Sqr((exeBox.X_Box(0, 1) - exeBox.X_Box(0, 0)) ^ 2 + (exeBox.Y_Box(0, 1) - exeBox.Y_Box(0, 0)) ^ 2)
                    MinX = exeBox.X_Box(1, 0)
                    MaxX = exeBox.X_Box(1, 1)
                    MinY = exeBox.Y_Box(1, 0)
                    MaxY = exeBox.Y_Box(1, 1)
                    For count1 = length To 0 Step -0.0001
                        count15 = count15 + 1
                        deltaX = (count1 / length) * (MaxX - MinX) + MinX
                        deltaY = (count1 / length) * (MaxY - MinY) + MinY
                        radXY = Sqr((deltaY - preBox.J_Box) ^ 2 + (deltaX - preBox.I_Box) ^ 2)
                        If radXY < (preBox.NewRadius - Comp) Then
                            exeBox.X_Box(1, 1) = deltaX
                            exeBox.Y_Box(1, 1) = deltaY
                            GoTo exception1C
                        End If
                    Next count1
exception1C:
                    DirIndStreight
                    G_01 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, PointI, PointJ, PointK
            End If
        End If
    ElseIf exeBox.G_Box = G02CW Then
        If exeBox.Offset = 0 Then
                G_02 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, exeBox.I_Box, exeBox.J_Box, exeBox.K_Box
        ElseIf exeBox.Offset > 0 Then
                G_02 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, exeBox.I_Box, exeBox.J_Box, exeBox.K_Box
                G_02 preBox.X_Box(1, 0), preBox.Y_Box(1, 0), exeBox.Z_Box(0, 1), IPM, exeBox.X_Box(0, 1), exeBox.Y_Box(0, 1), exeBox.K_Box
        ElseIf exeBox.Offset < 0 Then
            If preBox.G_Box = G00Q Or preBox.G_Box = G01L Then
                    length = Sqr((preBox.X_Box(0, 1) - preBox.X_Box(0, 0)) ^ 2 + (preBox.Y_Box(0, 1) - preBox.Y_Box(0, 0)) ^ 2)
                    MinX = preBox.X_Box(1, 0)
                    MaxX = preBox.X_Box(1, 1)
                    MinY = preBox.Y_Box(1, 0)
                    MaxY = preBox.Y_Box(1, 1)
                    For count1 = length To 0 Step -0.0001
                        count15 = count15 + 1
                        deltaX = (count1 / length) * (MaxX - MinX) + MinX
                        deltaY = (count1 / length) * (MaxY - MinY) + MinY
                        radXY = Sqr((deltaY - exeBox.J_Box) ^ 2 + (deltaX - exeBox.I_Box) ^ 2)
                        If radXY < (exeBox.NewRadius + Comp) Then
                            exeBox.X_Box(1, 1) = deltaX
                            exeBox.Y_Box(1, 1) = deltaY
                            GoTo exception1D
                        End If
                    Next count1
exception1D:
                    G_02 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, exeBox.I_Box, exeBox.J_Box, exeBox.K_Box
            ElseIf preBox.G_Box = G02CW Then
            '11111111111111111111111111111111
            ElseIf preBox.G_Box = G03CCW Then
            '22222222222222222222222222222222
                exeBox.Hyp_Box = Format(1 / (Cos(Abs(exeBox.Offset / 2)) / Comp), "#0.####")
                If exeBox.Hyp_Box > 6 Or exeBox.Hyp_Box < -6 Then
                    exeBox.Hyp_Box = 0
                    MsgBox "Fault in HYP BOX CALC"
                End If
                exeBox.X_Box(1, 1) = Format(X((exeBox.Offset / -2) + exeBox.Dir_Box(1) + halfPI, exeBox.Hyp_Box), "#0.####") + exeBox.X_Box(0, 1)
                exeBox.Y_Box(1, 1) = Format(Y((exeBox.Offset / -2) + exeBox.Dir_Box(1) + halfPI, exeBox.Hyp_Box), "#0.####") + exeBox.Y_Box(0, 1)
                G_02 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, exeBox.I_Box, exeBox.J_Box, exeBox.K_Box
            End If
        End If
    ElseIf exeBox.G_Box = G03CCW Then
        If exeBox.Offset = 0 Then
                G_03 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, exeBox.I_Box, exeBox.J_Box, exeBox.K_Box
        ElseIf exeBox.Offset > 0 Then
                G_03 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, exeBox.I_Box, exeBox.J_Box, exeBox.K_Box
                G_02 preBox.X_Box(1, 0), preBox.Y_Box(1, 0), exeBox.Z_Box(0, 1), IPM, exeBox.X_Box(0, 1), exeBox.Y_Box(0, 1), exeBox.K_Box
        ElseIf exeBox.Offset < 0 Then
            If preBox.G_Box = G00Q Or preBox.G_Box = G01L Then
            '00000000000000000000000000000000
                exeBox.Hyp_Box = Format(1 / (Cos(Abs(exeBox.Offset / 2)) / Comp), "#0.####")
                If exeBox.Hyp_Box > 6 Or exeBox.Hyp_Box < -6 Then
                    exeBox.Hyp_Box = 0
                    MsgBox "Fault in HYP BOX CALC"
                End If
                exeBox.X_Box(1, 1) = Format(X((exeBox.Offset / -2) + exeBox.Dir_Box(1) + halfPI, exeBox.Hyp_Box), "#0.####") + exeBox.X_Box(0, 1)
                exeBox.Y_Box(1, 1) = Format(Y((exeBox.Offset / -2) + exeBox.Dir_Box(1) + halfPI, exeBox.Hyp_Box), "#0.####") + exeBox.Y_Box(0, 1)
                G_03 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, exeBox.I_Box, exeBox.J_Box, exeBox.K_Box
            ElseIf preBox.G_Box = G02CW Then
            '11111111111111111111111111111111
                exeBox.Hyp_Box = Format(1 / (Cos(Abs(exeBox.Offset / 2)) / Comp), "#0.####")
                If exeBox.Hyp_Box > 6 Or exeBox.Hyp_Box < -6 Then
                    exeBox.Hyp_Box = 0
                    MsgBox "Fault in HYP BOX CALC"
                End If
                exeBox.X_Box(1, 1) = Format(X((exeBox.Offset / -2) + exeBox.Dir_Box(1) + halfPI, exeBox.Hyp_Box), "#0.####") + exeBox.X_Box(0, 1)
                exeBox.Y_Box(1, 1) = Format(Y((exeBox.Offset / -2) + exeBox.Dir_Box(1) + halfPI, exeBox.Hyp_Box), "#0.####") + exeBox.Y_Box(0, 1)
                G_03 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, exeBox.I_Box, exeBox.J_Box, exeBox.K_Box
            ElseIf preBox.G_Box = G03CCW Then
            '22222222222222222222222222222222
                exeBox.Hyp_Box = Format(1 / (Cos(Abs(exeBox.Offset / 2)) / Comp), "#0.####")
                If exeBox.Hyp_Box > 6 Or exeBox.Hyp_Box < -6 Then
                    exeBox.Hyp_Box = 0
                    MsgBox "Fault in HYP BOX CALC"
                End If
                exeBox.X_Box(1, 1) = Format(X((exeBox.Offset / -2) + exeBox.Dir_Box(1) + halfPI, exeBox.Hyp_Box), "#0.####") + exeBox.X_Box(0, 1)
                exeBox.Y_Box(1, 1) = Format(Y((exeBox.Offset / -2) + exeBox.Dir_Box(1) + halfPI, exeBox.Hyp_Box), "#0.####") + exeBox.Y_Box(0, 1)
                G_03 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, exeBox.I_Box, exeBox.J_Box, exeBox.K_Box
            End If
        End If
    Else
        MsgBox "G_Box Incorrect"
    End If
End Sub

Public Sub BoxCutRIGHT(G As G_Code, EndX As Single, EndY As Single, EndZ As Single, IPM As Single, PointI As Single, PointJ As Single, PointK As Single)
    Dim Di(4) As Single
    Dim dummy As Single
                    Dim length As Single
                    Dim MinX As Single
                    Dim MinY As Single
                    Dim MaxX As Single
                    Dim MaxY As Single
                    Dim deltaX As Single
                    Dim deltaY As Single
                    Dim radXY As Single
                    Dim count1 As Single
                    Dim count15 As Single
                    Dim instruct As String
    '***THE FOLLOWING SETS UP NON COMPENSATED PATHS
    Select Case exeBox.G_Box
        Case 0 To 1
            instruct = "Lin"
        Case 2
            instruct = "ArcCW"
        Case 3
            instruct = "ArcCCW"
    End Select
    Mainform.RichTextBox2.SelText = instruct + " X" + CStr(preBox.X_Box(0, 1)) + "Y" + CStr(preBox.Y_Box(0, 1)) + Chr(13) + Chr(10)
    exeBox = preBox 'before an exe pre process with pre
    preBox.IPM_Box = IPM '       :
    preBox.X_Box(0, 1) = EndX '              :PRE MOVE CONTROL POINTS
    preBox.Y_Box(0, 1) = EndY '              :PRE MOVE CONTROL POINTS
    preBox.Z_Box(0, 1) = EndZ '              :PRE MOVE CONTROL POINTS
    preBox.X_Box(0, 0) = exeBox.X_Box(0, 1) ':PRE MOVE CONTROL POINTS
    preBox.Y_Box(0, 0) = exeBox.Y_Box(0, 1) ':PRE MOVE CONTROL POINTS
    preBox.Z_Box(0, 0) = exeBox.Z_Box(0, 1) ':PRE MOVE CONTROL POINTS
    preBox.I_Box = PointI '    :
    preBox.J_Box = PointJ '    :
    preBox.K_Box = PointK '    :
    preBox.G_Box = G '
    '**********************************************
    
    '**********************************************
    If CutterComp = 2 Then 'CutterComp = 1 is Lefthand Compensation
        If LastCompLine = False And CutterComp = 2 Then 'checks for two instructions in que
            LastCompLine = True
            preBox.X_Box(0, 0) = X_inches: preBox.Y_Box(0, 0) = Y_inches: preBox.Z_Box(0, 0) = Z_inches 'Loads a start point
            'Dir_Box(0) is always this command  exiting direction
            preBox.Dir_Box(0) = Format(ATan2(preBox.Y_Box(0, 1) - preBox.Y_Box(0, 0), preBox.X_Box(0, 1) - preBox.X_Box(0, 0)), "0.###")
            preBox.Dir_Box(1) = preBox.Dir_Box(0)
            preBox.Dir_Box(2) = preBox.Dir_Box(0) - halfPI
            preBox.Dir_Box(3) = preBox.Dir_Box(1) - halfPI
            If preBox.Dir_Box(0) < 0 Then preBox.Dir_Box(0) = preBox.Dir_Box(0) + PI2
            If preBox.Dir_Box(0) > PI2 Then preBox.Dir_Box(0) = preBox.Dir_Box(0) - PI2
            If preBox.Dir_Box(1) < 0 Then preBox.Dir_Box(1) = preBox.Dir_Box(1) + PI2
            If preBox.Dir_Box(1) > PI2 Then preBox.Dir_Box(1) = preBox.Dir_Box(1) - PI2
            If preBox.Dir_Box(2) < 0 Then preBox.Dir_Box(2) = preBox.Dir_Box(2) + PI2
            If preBox.Dir_Box(2) > PI2 Then preBox.Dir_Box(2) = preBox.Dir_Box(2) - PI2
            If preBox.Dir_Box(3) < 0 Then preBox.Dir_Box(3) = preBox.Dir_Box(3) + PI2
            If preBox.Dir_Box(3) > PI2 Then preBox.Dir_Box(3) = preBox.Dir_Box(3) - PI2
            Exit Sub 'the first line is loaded
        End If
        
        If preBox.G_Box = 0 Or preBox.G_Box = 1 Then
            'Dir_Box(0) is always this command  exiting direction
            preBox.Dir_Box(0) = Format(ATan2(preBox.Y_Box(0, 1) - preBox.Y_Box(0, 0), preBox.X_Box(0, 1) - preBox.X_Box(0, 0)), "0.###")
            preBox.Dir_Box(1) = Format(preBox.Dir_Box(0), "0.###")
            preBox.Dir_Box(2) = Format(preBox.Dir_Box(0) - halfPI, "0.###")
            preBox.Dir_Box(3) = Format(preBox.Dir_Box(1) - halfPI, "0.###")
            dummy = dummy
        End If
        If preBox.G_Box = 2 Then
            preBox.NewRadius = Sqr((preBox.J_Box - preBox.Y_Box(0, 0)) ^ 2 + (preBox.I_Box - preBox.X_Box(0, 0)) ^ 2)
            'Dir_Box(0) is always this CW command  enter direction
            preBox.Dir_Box(0) = Format(ATan2(preBox.J_Box - preBox.Y_Box(0, 0), preBox.I_Box - preBox.X_Box(0, 0)) + halfPI, "0.###")
            'Dir_Box(1) is always this CW command  exit direction
            preBox.Dir_Box(1) = Format(ATan2(preBox.J_Box - preBox.Y_Box(0, 1), preBox.I_Box - preBox.X_Box(0, 1)) + halfPI, "0.###")
            preBox.Dir_Box(2) = Format(preBox.Dir_Box(0) - halfPI, "0.###")
            preBox.Dir_Box(3) = Format(preBox.Dir_Box(1) - halfPI, "0.###")
            dummy = dummy
        End If
        If preBox.G_Box = 3 Then
            preBox.NewRadius = Sqr((preBox.J_Box - preBox.Y_Box(0, 0)) ^ 2 + (preBox.I_Box - preBox.X_Box(0, 0)) ^ 2)
            'Dir_Box(1) is always this CW command  entering direction
            preBox.Dir_Box(0) = Format(ATan2(preBox.Y_Box(0, 0) - preBox.J_Box, preBox.X_Box(0, 0) - preBox.I_Box) + halfPI, "0.###")
            'Dir_Box(0) is always this CW command  exiting direction
            preBox.Dir_Box(1) = Format(ATan2(preBox.Y_Box(0, 1) - preBox.J_Box, preBox.X_Box(0, 1) - preBox.I_Box) + halfPI, "0.###")
            preBox.Dir_Box(2) = Format(preBox.Dir_Box(0) - halfPI, "0.###")
            preBox.Dir_Box(3) = Format(preBox.Dir_Box(1) - halfPI, "0.###")
            dummy = dummy
        End If
    End If
    'Normal Range********************
    If preBox.Dir_Box(0) < 0 Then preBox.Dir_Box(0) = Format(preBox.Dir_Box(0) + PI2, "0.###")
    If preBox.Dir_Box(0) >= PI2 Then preBox.Dir_Box(0) = Format(preBox.Dir_Box(0) - PI2, "0.###")
    If preBox.Dir_Box(1) < 0 Then preBox.Dir_Box(1) = Format(preBox.Dir_Box(1) + PI2, "0.###")
    If preBox.Dir_Box(1) >= PI2 Then preBox.Dir_Box(1) = Format(preBox.Dir_Box(1) - PI2, "0.###")
    If preBox.Dir_Box(2) < 0 Then preBox.Dir_Box(2) = Format(preBox.Dir_Box(2) + PI2, "0.###")
    If preBox.Dir_Box(2) >= PI2 Then preBox.Dir_Box(2) = Format(preBox.Dir_Box(2) - PI2, "0.###")
    If preBox.Dir_Box(3) < 0 Then preBox.Dir_Box(3) = Format(preBox.Dir_Box(3) + PI2, "0.###")
    If preBox.Dir_Box(3) >= PI2 Then preBox.Dir_Box(3) = Format(preBox.Dir_Box(3) - PI2, "0.###")
    dummy = dummy
    'Normal Range********************
    exeBox.Offset = Format(exeBox.Dir_Box(1) - preBox.Dir_Box(0), "0.##")
    If exeBox.Offset + PI <= -0.0001 Then exeBox.Offset = Format(exeBox.Offset + PI2, "0.###")
    If exeBox.Offset >= PI + 0.0001 Then exeBox.Offset = Format(exeBox.Offset - PI2, "0.###")
    '********************************
    'default
    preBox.X_Box(1, 0) = Format(X(preBox.Dir_Box(2), Comp) + preBox.X_Box(0, 0), "#0.####")
    preBox.X_Box(1, 1) = Format(X(preBox.Dir_Box(3), Comp) + preBox.X_Box(0, 1), "#0.####")
    preBox.Y_Box(1, 0) = Format(Y(preBox.Dir_Box(2), Comp) + preBox.Y_Box(0, 0), "#0.####")
    preBox.Y_Box(1, 1) = Format(Y(preBox.Dir_Box(3), Comp) + preBox.Y_Box(0, 1), "#0.####")
    If exeBox.G_Box = G00Q Or exeBox.G_Box = G01L Then
        If exeBox.Offset = 0 Then
                DirIndStreight
                G_01 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, PointI, PointJ, PointK
        ElseIf exeBox.Offset < 0 Then
                DirIndStreight
                G_01 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, PointI, PointJ, PointK
                G_03 preBox.X_Box(1, 0), preBox.Y_Box(1, 0), exeBox.Z_Box(0, 1), IPM, exeBox.X_Box(0, 1), exeBox.Y_Box(0, 1), exeBox.K_Box
        ElseIf exeBox.Offset > 0 Then
            If preBox.G_Box = G00Q Or preBox.G_Box = G01L Then
                exeBox.Hyp_Box = Format(1 / (Cos(Abs(exeBox.Offset / 2)) / Comp), "#0.####")
                If exeBox.Hyp_Box > 6 Or exeBox.Hyp_Box < -6 Then
                    exeBox.Hyp_Box = 0
                    MsgBox "Fault in HYP BOX CALC"
                End If
                exeBox.X_Box(1, 1) = Format(X((exeBox.Offset / -2) + exeBox.Dir_Box(1) - halfPI, exeBox.Hyp_Box), "#0.####") + exeBox.X_Box(0, 1)
                exeBox.Y_Box(1, 1) = Format(Y((exeBox.Offset / -2) + exeBox.Dir_Box(1) - halfPI, exeBox.Hyp_Box), "#0.####") + exeBox.Y_Box(0, 1)
                DirIndStreight
                G_01 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, PointI, PointJ, PointK
            ElseIf preBox.G_Box = G02CW Then
                    length = Sqr((exeBox.X_Box(0, 1) - exeBox.X_Box(0, 0)) ^ 2 + (exeBox.Y_Box(0, 1) - exeBox.Y_Box(0, 0)) ^ 2)
                    MinX = exeBox.X_Box(1, 0)
                    MaxX = exeBox.X_Box(1, 1)
                    MinY = exeBox.Y_Box(1, 0)
                    MaxY = exeBox.Y_Box(1, 1)
                    For count1 = 0 To length Step 0.0001
                        count15 = count15 + 1
                        deltaX = (count1 / length) * (MaxX - MinX) + MinX
                        deltaY = (count1 / length) * (MaxY - MinY) + MinY
                        radXY = Sqr((deltaY - preBox.J_Box) ^ 2 + (deltaX - preBox.I_Box) ^ 2)
                        If radXY > (preBox.NewRadius + Comp) Then
                            exeBox.X_Box(1, 1) = deltaX
                            exeBox.Y_Box(1, 1) = deltaY
                            GoTo exception1B
                        End If
                    Next count1
exception1B:
                    DirIndStreight
                    G_01 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, PointI, PointJ, PointK
            ElseIf preBox.G_Box = G03CCW Then
                    length = Sqr((exeBox.X_Box(0, 1) - exeBox.X_Box(0, 0)) ^ 2 + (exeBox.Y_Box(0, 1) - exeBox.Y_Box(0, 0)) ^ 2)
                    MinX = exeBox.X_Box(1, 0)
                    MaxX = exeBox.X_Box(1, 1)
                    MinY = exeBox.Y_Box(1, 0)
                    MaxY = exeBox.Y_Box(1, 1)
                    For count1 = length To 0 Step -0.0001
                        count15 = count15 + 1
                        deltaX = (count1 / length) * (MaxX - MinX) + MinX
                        deltaY = (count1 / length) * (MaxY - MinY) + MinY
                        radXY = Sqr((deltaY - preBox.J_Box) ^ 2 + (deltaX - preBox.I_Box) ^ 2)
                        If radXY > (preBox.NewRadius + Comp) Then
                            exeBox.X_Box(1, 1) = deltaX
                            exeBox.Y_Box(1, 1) = deltaY
                            GoTo exception1C
                        End If
                    Next count1
exception1C:
                    DirIndStreight
                    G_01 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, PointI, PointJ, PointK
            End If
        End If
    ElseIf exeBox.G_Box = G02CW Then
        If exeBox.Offset = 0 Then
                G_02 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, exeBox.I_Box, exeBox.J_Box, exeBox.K_Box
        ElseIf exeBox.Offset < 0 Then
                G_02 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, exeBox.I_Box, exeBox.J_Box, exeBox.K_Box
                G_03 preBox.X_Box(1, 0), preBox.Y_Box(1, 0), exeBox.Z_Box(0, 1), IPM, exeBox.X_Box(0, 1), exeBox.Y_Box(0, 1), exeBox.K_Box
        ElseIf exeBox.Offset > 0 Then
            If preBox.G_Box = G00Q Or preBox.G_Box = G01L Then
                    length = Sqr((preBox.X_Box(0, 1) - preBox.X_Box(0, 0)) ^ 2 + (preBox.Y_Box(0, 1) - preBox.Y_Box(0, 0)) ^ 2)
                    MinX = preBox.X_Box(1, 0)
                    MaxX = preBox.X_Box(1, 1)
                    MinY = preBox.Y_Box(1, 0)
                    MaxY = preBox.Y_Box(1, 1)
                    For count1 = length To 0 Step -0.0001
                        count15 = count15 + 1
                        deltaX = (count1 / length) * (MaxX - MinX) + MinX
                        deltaY = (count1 / length) * (MaxY - MinY) + MinY
                        radXY = Sqr((deltaY - exeBox.J_Box) ^ 2 + (deltaX - exeBox.I_Box) ^ 2)
                        If radXY < (exeBox.NewRadius + Comp) Then
                            exeBox.X_Box(1, 1) = deltaX
                            exeBox.Y_Box(1, 1) = deltaY
                            GoTo exception1D
                        End If
                    Next count1
exception1D:
                    G_02 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, exeBox.I_Box, exeBox.J_Box, exeBox.K_Box
            ElseIf preBox.G_Box = G02CW Then
            '11111111111111111111111111111111
            ElseIf preBox.G_Box = G03CCW Then
                exeBox.Hyp_Box = Format(1 / (Cos(Abs(exeBox.Offset / 2)) / Comp), "#0.####")
                If exeBox.Hyp_Box > 6 Or exeBox.Hyp_Box < -6 Then
                    exeBox.Hyp_Box = 0
                    MsgBox "Fault in HYP BOX CALC"
                End If
                exeBox.X_Box(1, 1) = Format(X((exeBox.Offset / -2) + exeBox.Dir_Box(1) - halfPI, exeBox.Hyp_Box), "#0.####") + exeBox.X_Box(0, 1)
                exeBox.Y_Box(1, 1) = Format(Y((exeBox.Offset / -2) + exeBox.Dir_Box(1) - halfPI, exeBox.Hyp_Box), "#0.####") + exeBox.Y_Box(0, 1)
                G_02 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, exeBox.I_Box, exeBox.J_Box, exeBox.K_Box
            End If
        End If
    ElseIf exeBox.G_Box = G03CCW Then
        If exeBox.Offset = 0 Then
                G_03 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, exeBox.I_Box, exeBox.J_Box, exeBox.K_Box
        ElseIf exeBox.Offset < 0 Then
                G_03 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, exeBox.I_Box, exeBox.J_Box, exeBox.K_Box
                G_02 preBox.X_Box(1, 0), preBox.Y_Box(1, 0), exeBox.Z_Box(0, 1), IPM, exeBox.X_Box(0, 1), exeBox.Y_Box(0, 1), exeBox.K_Box
        ElseIf exeBox.Offset > 0 Then
            If preBox.G_Box = G00Q Or preBox.G_Box = G01L Then
                exeBox.Hyp_Box = Format(1 / (Cos(Abs(exeBox.Offset / 2)) / Comp), "#0.####")
                If exeBox.Hyp_Box > 6 Or exeBox.Hyp_Box < -6 Then
                    exeBox.Hyp_Box = 0
                    MsgBox "Fault in HYP BOX CALC"
                End If
                exeBox.X_Box(1, 1) = Format(X((exeBox.Offset / -2) + exeBox.Dir_Box(1) - halfPI, exeBox.Hyp_Box), "#0.####") + exeBox.X_Box(0, 1)
                exeBox.Y_Box(1, 1) = Format(Y((exeBox.Offset / -2) + exeBox.Dir_Box(1) - halfPI, exeBox.Hyp_Box), "#0.####") + exeBox.Y_Box(0, 1)
                G_03 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, exeBox.I_Box, exeBox.J_Box, exeBox.K_Box
            ElseIf preBox.G_Box = G02CW Then
                exeBox.Hyp_Box = Format(1 / (Cos(Abs(exeBox.Offset / 2)) / Comp), "#0.####")
                If exeBox.Hyp_Box > 6 Or exeBox.Hyp_Box < -6 Then
                    exeBox.Hyp_Box = 0
                    MsgBox "Fault in HYP BOX CALC"
                End If
                exeBox.X_Box(1, 1) = Format(X((exeBox.Offset / -2) + exeBox.Dir_Box(1) - halfPI, exeBox.Hyp_Box), "#0.####") + exeBox.X_Box(0, 1)
                exeBox.Y_Box(1, 1) = Format(Y((exeBox.Offset / -2) + exeBox.Dir_Box(1) - halfPI, exeBox.Hyp_Box), "#0.####") + exeBox.Y_Box(0, 1)
                G_03 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, exeBox.I_Box, exeBox.J_Box, exeBox.K_Box
            ElseIf preBox.G_Box = G03CCW Then
                exeBox.Hyp_Box = Format(1 / (Cos(Abs(exeBox.Offset / 2)) / Comp), "#0.####")
                If exeBox.Hyp_Box > 6 Or exeBox.Hyp_Box < -6 Then
                    exeBox.Hyp_Box = 0
                    MsgBox "Fault in HYP BOX CALC"
                End If
                exeBox.X_Box(1, 1) = Format(X((exeBox.Offset / -2) + exeBox.Dir_Box(1) + halfPI, exeBox.Hyp_Box), "#0.####") + exeBox.X_Box(0, 1)
                exeBox.Y_Box(1, 1) = Format(Y((exeBox.Offset / -2) + exeBox.Dir_Box(1) + halfPI, exeBox.Hyp_Box), "#0.####") + exeBox.Y_Box(0, 1)
                G_03 exeBox.X_Box(1, 1), exeBox.Y_Box(1, 1), exeBox.Z_Box(0, 1), exeBox.IPM_Box, exeBox.I_Box, exeBox.J_Box, exeBox.K_Box
            End If
        End If
    Else
        MsgBox "G_Box Incorrect"
    End If
End Sub

Public Sub G_01(EndX As Single, EndY As Single, EndZ As Single, IPM As Single, PointI As Single, PointJ As Single, PointK As Single)
    Dim finX As Long
    Dim finY As Long
    Dim finZ As Long
    EndX = EndX '* (1 + Pict.Slider2 / 10)
    EndY = EndY '* (1 + Pict.Slider2 / 10)
    EndZ = EndZ
    finX = EndX * 8000 '- DrawingOffset.PPX
    finY = EndY * 8000 '- DrawingOffset.PPY
    finZ = EndZ * 8000
    G_01A EndX, EndY, EndZ, IPM, PointI, PointJ, PointK
    Speed = IPM
    Mainform.Label3.Caption = Speed
    If blnSimulate = False Then
        'If IPM < 34 Then
            'If acc_dec = False Then
                'testacc = True
                'acc_dec = True
                'Mainform.cmdInteruptCount(2).BackColor = &HFF00&
                'Mainform.cmdInteruptCount_Click (4)
                'Do
                    'DoEvents
                'Loop Until blnWaitForComm = False
            'End If
            
        'End If
        'If IPM > 33 Then
            'If testacc = True Then
                'testacc = False
                'acc_dec = False
                'Mainform.cmdInteruptCount(2).BackColor = &H8000000F
                'Mainform.cmdInteruptCount_Click (4)
                'Do
                    'DoEvents
                'oop Until blnWaitForComm = False
            'End If
        'End If
        Mainform.sendDataL finX, finY, finZ, "G01", 0, 0, 0, CLng(IPM)
    
    End If
End Sub

Public Sub G_01A(EndX As Single, EndY As Single, EndZ As Single, IPM As Single, PointI As Single, PointJ As Single, PointK As Single)
    On Error Resume Next
    Static zlow As Single
    Static zfrac As Single
    
    Dim count13 As Single
    Dim newx As Single
    Dim newy As Single
    Dim newz As Single
    Dim Zbright1 As Byte
    Dim Zbright2 As Byte
    'Dim PauseTime, Start
    Dim StartX As Long
    Dim StartY As Long
    Dim StartZ As Long
    Dim deltaX As Long
    Dim deltaY As Long
    Dim deltaZ As Long
    Dim finX As Long
    Dim finY As Long
    Dim finZ As Long
    Dim length As Long
    Dim dummyLength As Long
    Dim bright As Long
    StartX = X_p
    StartY = Y_p
    StartZ = Z_p
    finX = EndX * 2000
    finY = EndY * 2000
    finZ = EndZ * 2000
    deltaX = (finX - StartX)
    deltaY = (finY - StartY)
    deltaZ = (finZ - StartZ)
    length = Sqr(deltaX ^ 2 + deltaY ^ 2 + deltaZ ^ 2)
    If EndX < Max_X_N Then
        Max_X_N = EndX
        Pict.Label4 = "Max X- = " & Max_X_N
    End If
    If EndX > Max_X_P Then
        Max_X_P = EndX
        Pict.Label3 = "Max X+ = " & Max_X_P
    End If
    If EndY < Max_Y_N Then
        Max_Y_N = EndY
        Pict.Label2 = "Max Y- = " & Max_Y_N
    End If
    If EndY > Max_Y_P Then
        Max_Y_P = EndY
        Pict.Label1 = "Max Y+ = " & Max_Y_P
    End If
    For dummyLength = 1 To length
        If X_p < finX Then
            If X_p < ((deltaX / length) * dummyLength + StartX) Then
                X_p = X_p + 1
                If X_p > 46080 Then X_p = 46080
                Mainform.Label2.Caption = Format((((X_p + 10000) / 20000) * 10) - 5, "##0.0000")
                If mainlostfocus = False Then Mainform.Shape1(0).Left = ((X_p - 10000) / -20000) * 56 + 80
            End If
        End If
        
        If X_p > finX Then
            If X_p > ((deltaX / length) * dummyLength + StartX) Then
                X_p = X_p - 1
                If X_p < -46080 Then X_p = -46080
                Mainform.Label2.Caption = Format((((X_p + 10000) / 20000) * 10) - 5, "##0.0000")
                If mainlostfocus = False Then Mainform.Shape1(0).Left = ((X_p - 10000) / -20000) * 56 + 80
            End If
        End If
        
        If Y_p < finY Then
            If Y_p < ((deltaY / length) * dummyLength + StartY) Then
                Y_p = Y_p + 1
                If Y_p > 46080 Then Y_p = 46080
                Mainform.Label1.Caption = Format((((Y_p + 10000) / 20000) * 10) - 5, "##0.0000")
                If mainlostfocus = False Then Mainform.Shape1(0).Top = ((Y_p + 10000) / 20000) * 44 + 290
            End If
        End If
        
        If Y_p > finY Then
            If Y_p > ((deltaY / length) * dummyLength + StartY) Then
                Y_p = Y_p - 1
                If Y_p < -46080 Then Y_p = -46080
                Mainform.Label1.Caption = Format((((Y_p + 10000) / 20000) * 10) - 5, "##0.0000")
                If mainlostfocus = False Then Mainform.Shape1(0).Top = ((Y_p + 10000) / 20000) * 44 + 290
            End If
        End If
        
        If Z_p < finZ Then
            If Z_p < ((deltaZ / length) * dummyLength + StartZ) Then
                Z_p = Z_p + 1
                If Z_p > 46080 Then Z_p = 46080
                Mainform.Label7.Caption = Format((((Z_p + 10000) / 20000) * 10) - 5, "##0.0000")
                'Mainform.Shape1(0).Top = ((Z_P + 9600) / (9600 + 9600)) * (396 - 200) + 200
            End If
        End If
        
        If Z_p > finZ Then
            If Z_p > ((deltaZ / length) * dummyLength + StartZ) Then
                Z_p = Z_p - 1
                If Z_p < -46080 Then Z_p = -46080
                Mainform.Label7.Caption = Format((((Z_p + 10000) / 20000) * 10) - 5, "##0.0000")
                'Mainform.Shape1(0).Top = ((Z_P + 9600) / (9600 + 9600)) * (396 - 200) + 200
            End If
        End If
        LeftRight = 400
        UpDown = 350
            If Z_p < zlow Then zlow = Z_p
            zfrac = zlow / 128
            'End If
            If Z_p > -2500 And zfrac <= 0 Then 'z_p < 1 Or
                Zbright1 = 256 - Z_p * (1 / zfrac)
            End If
            Zbright2 = Zbright1 / 2
            newx = X_p * decimalXY
            newy = Y_p * -decimalXY
            newz = Z_p * decimalXY
            newx = newx + 0.7 * newy
            newy = newy - 0.2 * (X_p / 10 * decimalXY) + -newz * 2
        If CutterComp = 1 Then
            If Z_p <= 0 Then
                If X_p = 0 And Y_p = 0 Then
                    Pict.PSet (X_p * decimalXY + LeftRight, Y_p * -decimalXY + UpDown), RGB(90, 255, 90)
                    PictIso.PSet (newx + LeftRight, newy + UpDown), RGB(Zbright2, Zbright1, Zbright2)
                Else
                    Pict.PSet (X_p * decimalXY + LeftRight, Y_p * -decimalXY + UpDown), RGB(64, 255, 64)
                    PictIso.PSet (newx + LeftRight, newy + UpDown), RGB(Zbright2, Zbright1, Zbright2)
                End If
            Else
                Zbright1 = 130
                Zbright2 = 130
                Pict.PSet (X_p * decimalXY + LeftRight, Y_p * -decimalXY + UpDown), RGB(100, 100, 100)
                PictIso.PSet (newx + LeftRight, newy + UpDown), RGB(Zbright2, Zbright1, Zbright2)
            End If
        ElseIf CutterComp = 0 Then
            If Z_p <= 0 Then
                If X_p = 0 And Y_p = 0 Then
                    Pict.PSet (X_p * decimalXY + LeftRight, Y_p * -decimalXY + UpDown), RGB(90, 90, 255)
                    PictIso.PSet (newx + LeftRight, newy + UpDown), RGB(Zbright2, Zbright2, Zbright1)
                Else
                    Pict.PSet (X_p * decimalXY + LeftRight, Y_p * -decimalXY + UpDown), RGB(64, 64, 255)
                    PictIso.PSet (newx + LeftRight, newy + UpDown), RGB(Zbright2, Zbright2, Zbright1)
                End If
            Else
                Zbright1 = 130
                Zbright2 = 130
                
                If ZHigh = False Then
                    Pict.PSet (X_p * decimalXY + LeftRight, Y_p * -decimalXY + UpDown), RGB(128, 100, 128)
                    PictIso.PSet (newx + LeftRight, newy + UpDown), RGB(Zbright2, Zbright2, Zbright1)
                End If
            End If
        ElseIf CutterComp = 2 Then
            If Z_p <= 0 Then
                If X_p = 0 And Y_p = 0 Then
                    Pict.PSet (X_p * decimalXY + LeftRight, Y_p * -decimalXY + UpDown), RGB(255, 64, 64)
                    PictIso.PSet (newx + LeftRight, newy + UpDown), RGB(Zbright1, Zbright2, Zbright2)
                Else
                    Pict.PSet (X_p * decimalXY + LeftRight, Y_p * -decimalXY + UpDown), RGB(255, 64, 64)
                    PictIso.PSet (newx + LeftRight, newy + UpDown), RGB(Zbright1, Zbright2, Zbright2)
                End If
            Else
                Zbright1 = 130
                Zbright2 = 130
                Pict.PSet (X_p * decimalXY + LeftRight, Y_p * -decimalXY + UpDown), RGB(128, 100, 128)
                PictIso.PSet (newx + LeftRight, newy + UpDown), RGB(Zbright1, Zbright2, Zbright2)
            End If
        End If
        LeftRight = 0
    Next dummyLength
End Sub

Public Sub G_02(EndX As Single, EndY As Single, EndZ As Single, IPM As Single, PointI As Single, PointJ As Single, PointK As Single)
    On Error Resume Next
    DirIndCW
    Dim Radius As Single
    Dim RadianLength As Long
    Dim CountRadians As Single
    Dim StartRadians As Single
    Dim EndRadians As Single
    Dim StartX As Long
    Dim StartY As Long
    Dim StartZ As Long
    Dim auxSR As Long
    Dim CenterX As Single
    Dim CenterY As Single
    Dim CenterZ As Single
    Dim FinishX As Long
    Dim FinishY As Long
    Dim FinishZ As Long
    Dim newx As Single
    Dim newy As Single
    Dim newz As Single
    Dim currentX As Single
    Dim currentY As Single
    Dim currentZ As Single
    Dim movment As Single
    StartX = X_p
    StartY = Y_p
    StartZ = Z_p
    CenterX = PointI * 2000
    CenterY = PointJ * 2000
    CenterZ = PointK * 2000
    FinishX = EndX * 2000
    FinishY = EndY * 2000
    FinishZ = StartZ - (EndZ * 2000)
    If FinishZ <> 0 Then
        newz = newz
    End If
'**************CLOCK WISE IS BIG TO SMALL CountRadians!!!!*********
    Radius = Sqr((CenterX - StartX) ^ 2 + (CenterY - StartY) ^ 2)
    StartRadians = ATan2((StartY - CenterY), (StartX - CenterX))
    EndRadians = ATan2((FinishY - CenterY), (FinishX - CenterX))
    auxSR = StartRadians * 1000000
    If StartRadians <= EndRadians Then StartRadians = StartRadians + PI2
    For CountRadians = StartRadians To EndRadians Step -0.0001 'clockwise
        'A circle is alot of lil lines.
        newx = X(CountRadians, Radius): newy = Y(CountRadians, Radius): newz = -FinishZ * ((CountRadians - StartRadians) / (EndRadians - StartRadians))
        If currentX <> newx Or currentY <> newy Then
            currentX = newx: currentY = newy: currentZ = newz
            G_01A (currentX + CenterX) / 2000, (currentY + CenterY) / 2000, (StartZ + newz) / 2000, IPM, 0, 0, 0 '+ (newZ / 2000)
        End If
    Next CountRadians
    CenterX = PointI * 8000
    CenterY = PointJ * 8000
    FinishZ = EndZ * 8000
    Radius = Abs(Radius) * 4 '* 8000 '* 8000
    RadianLength = Abs(StartRadians - EndRadians) * 1000000
    
    Mainform.sendDataL CLng(CenterX), CLng(CenterY), FinishZ, "G02", CLng(Radius), RadianLength, auxSR
End Sub
'Inverse Sine Arcsin(X) = Atn(X / Sqr(-X * X + 1))
'Inverse Cosine Arccos(X) = Atn(-X / Sqr(-X * X + 1)) + 2 * Atn(1)
Public Sub G_03(EndX As Single, EndY As Single, EndZ As Single, IPM As Single, PointI As Single, PointJ As Single, PointK As Single)
    On Error Resume Next
    DirIndCCW
    Dim Radius As Single
    Dim RadianLength As Long
    Dim CountRadians As Single
    Dim StartRadians As Single
    Dim EndRadians As Single
    Dim StartX As Long
    Dim StartY As Long
    Dim StartZ As Long
    Dim auxSR As Long
    Dim CenterX As Single
    Dim CenterY As Single
    Dim CenterZ As Single
    Dim FinishX As Long
    Dim FinishY As Long
    Dim FinishZ As Long
    Dim newx As Single
    Dim newy As Single
    Dim newz As Single
    Dim currentX As Single
    Dim currentY As Single
    Dim currentZ As Single
    Dim movment As Single
    StartX = X_p
    StartY = Y_p
    StartZ = Z_p
    CenterX = PointI * 2000 'pulses/in
    CenterY = PointJ * 2000
    CenterZ = PointK * 2000
    FinishX = EndX * 2000
    FinishY = EndY * 2000
    FinishZ = StartZ - (EndZ * 2000)
    If FinishZ <> 0 Then
        newz = newz
    End If
'**************COUNTER CLOCK WISE IS SMALL TO BIGCOUNT1!!!!*********
    Radius = Sqr((CenterX - StartX) ^ 2 + (CenterY - StartY) ^ 2)
    StartRadians = ATan2((StartY - CenterY), (StartX - CenterX))
    EndRadians = ATan2((FinishY - CenterY), (FinishX - CenterX))
    
    If StartRadians >= EndRadians Then EndRadians = EndRadians + PI2
    For CountRadians = StartRadians To EndRadians Step 0.0001 'counterclockwise
        newx = X(CountRadians, Radius): newy = Y(CountRadians, Radius): newz = -FinishZ * ((StartRadians - CountRadians) / (StartRadians - EndRadians))
        If currentX <> newx Or currentY <> newy Or currentZ <> newz Then
            currentX = newx: currentY = newy: currentZ = newz
            G_01A (currentX + CenterX) / 2000, (currentY + CenterY) / 2000, (StartZ + newz) / 2000, IPM, 0, 0, 0 '+ (newZ / 2000)
        End If
        'A circle is alot of lil lines. ;-}
    Next CountRadians
    CenterX = PointI * 8000
    CenterY = PointJ * 8000
    FinishZ = EndZ * 8000
    Radius = Abs(Radius) * 4 '* 8000
    auxSR = StartRadians * 1000000
    RadianLength = Abs(StartRadians - EndRadians) * 1000000
    
    Mainform.sendDataL CLng(CenterX), CLng(CenterY), FinishZ, "G03", CLng(Radius), RadianLength, auxSR
    
End Sub
